//                            
//                              
//                           
//                            
//                          
//  Copyright (c) 02.2000 by ToMaS for DJGPP

  char MOUSE_LEFTBUTTON;
  char MOUSE_RIGHTBUTTON;
  char MOUSE_INSTALLED;
  unsigned int  MOUSE_X;
  unsigned int  MOUSE_Y;
int mouse_setposition(int x1,int y1);
int mouse_setxrange(int x1,int x2);
int mouse_setyrange(int y1,int y2);
int mouse_installed(void);
int mouse_speed(int speed);
int mouse_update(void);
int mouse_getbutton(void);
int mouse_getx(void);
int mouse_gety(void);

int mouse_setposition(int x1,int y1)
{ union REGS regs;
  regs.x.ax=4;
  regs.x.cx=x1*2;
  regs.x.dx=y1;
  int86(0x33, &regs, &regs);
  return 0;
}
int mouse_setxrange(int x1,int x2)
{ union REGS regs;
  regs.x.ax=7;
  regs.x.cx=x1;
  regs.x.dx=x2*2;
  int86(0x33, &regs, &regs);
  return 0;
}
int mouse_setyrange(int y1,int y2)
{ union REGS regs;
  regs.x.ax=8;
  regs.x.cx=y1;
  regs.x.dx=y2;
  int86(0x33, &regs, &regs);
  return 0;
}
int mouse_installed(void)
{ union REGS regs;
  regs.x.ax=0;
  int86(0x33, &regs, &regs);
  MOUSE_INSTALLED=regs.x.ax;
  return (MOUSE_INSTALLED);
}
int mouse_speed(int speed)
{ union REGS regs;
  regs.x.ax = 15;
  regs.x.cx = speed;
  regs.x.dx = speed;
  int86(0x33, &regs, &regs);
  return 0;
}
int mouse_getbutton(void)
{
  return (MOUSE_RIGHTBUTTON|MOUSE_LEFTBUTTON);
}
int mouse_getx(void)
{
  return(MOUSE_X);
}
int mouse_gety(void)
{
  return(MOUSE_Y);
}
unsigned int tipkam;
int mouse_update(void)
{ asm ("
    movb $3, %%eax;
    int $0x33;
    movw %%cx, _MOUSE_X;
    movw %%dx, _MOUSE_Y;
    movw %%bx, _tipkam;
    ": : : "%eax", "%ebx", "%ecx", "%edx", "%edi", "%esi", "memory", "cc" );
    if((tipkam&1)==1){MOUSE_LEFTBUTTON=1;}else{MOUSE_LEFTBUTTON=0;}
    if((tipkam&2)==2){MOUSE_RIGHTBUTTON=1;}else{MOUSE_RIGHTBUTTON=0;}
    MOUSE_X/=2;
    return (0);
}